C*****************************************
       program combine segments
C*****************************************
       implicit none
	   
	   integer CD
	   parameter (CD=11600)
	   real e1, e2, temp, value1, value2, tri, s
	   real tj_1, tj_2
	   real xi1, xf1, yi1, yf1, xi2, xf2, yi2, yf2
	   integer match, i, j, nnline, change, ii, start, trips
	   integer kk, ll, index, header, hash
	   integer file_n, first, last, msf, lsf
	   character*1 one
	   character*1 two
	   character*8 keyword
	   character*40 tempword
	   character*16 version
	   character*100 inline
	   character*100 inline2	   
	   
	   dimension e1(3), e2(3), tri(12,3), s(14,CD)
	   dimension tj_1(10000,5), tj_2(10000,5)
	   
       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM COMBINES LISTS OF LINE SEGMENTS'
	   write(6,*) ' AND THE WRITES THEM TO A SINGLE ORDERED LIST  '	 
	   write(6,*) ' IN A FILE ' 
	   write(6,*)
	   write(6,*) ' DEVELOPED BY CMU MRSEC'
	   write(6,*) ' rohrer@cmu.edu'	   
	   write(6,*) ' version 03/15/10'
       write(6,*) '=============================================='

       !compile with gfortran combine_segs.f -O3 -o combine_segs
       version = 'version 03/15/10'

 5     format(A)
       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) first
	   read(21,*) last
	   read(21,5) inline2	   
	   
       close(21)
  
	   open (34, file='all_segments.txt', status='unknown')
  
       do file_n=first,last

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 8
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 8
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	    goto 8
	   endif
 
 8     continue	 

c  This part is to determines the total number of line segments (lines in the data file)

		nnline = 0

 10     continue
		read(32,*,end=11)
		nnline=nnline+1
		goto 10
 11     continue
        close(32)
 12    	format(A,I7,A,I3,A)
 
		write(6,12) 'There are',nnline,' lines in file',file_n,'.'		
		
        if (nnline.gt.CD) then 
          write(6,*)'you must increase the size of the s array.  Bye.'
          goto 9020
		endif  

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 18
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.10) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 18
	   endif	
		
	   if (file_n.gt.9.and.file_n.lt.100) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown') 
	    goto 18
	   endif
 
 18     continue	 


c   Read the data into the segment matrix

c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		
       header = 0
       hash = 0
	   do i=1,nnline
	    read(32, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
		 if (file_n.eq.first) then
		  write(34, "(a)")inline
		 endif
	    else
		 goto 80     
	    endif			
	   enddo
 80   continue

 81   format(A,A)
      if (file_n.eq.first) then
	  write(34,81)'# comment: ',inline2
	  write(34,81)'# segment file written by combine_segs: ',version
      endif

	  header=header+1
		
		do i=header,nnline
!		 read(32,*,end=100) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i), 		
!     &	 s(6,i), s(7,i), s(8,i), s(9,i), s(10,i), s(11,i), s(12,i),
!     &   s(13,i), s(14,i)
!  use for files with 14 columns
	 
		 read(32,*,end=100) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i), 		
     &	 s(6,i), s(7,i), s(8,i), s(9,i), s(10,i), s(11,i), s(12,i)
	 
		enddo
 100    continue		
		close (32)


 250     format(7f9.3,f8.2,4f11.2)
c        The next step is to write out all of the data


		  
		 
         do i=header,nnline
		write(34,250) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i), 		
     &	 s(6,i), s(7,i), s(8,i), s(9,i), s(10,i), s(11,i), s(12,i)
	 
          enddo
		
		enddo
		
		close(34)
	   
 9020  continue	   
       end